require "libs.triangle"
function LoadMesh(filename)
    local triangles = {}
    local lines = {}
    local start = love.timer.getTime()
    for line in love.filesystem.lines(filename) do 
        lines[#lines + 1] = line
    end
    for i=1, 3 do --get rid of unnessecary header
         table.remove(lines, 1)
    end
    --load vector
    local j = 1
    local vector = {}
    local c = 0
    local stop = false
    while stop == false do 
        vector[j] = {}
        for num in string.gmatch(lines[j],"%S+") do
            if num ~= "v"  then
                if num == "s" then 
                    stop = true
                end
                if stop == false then 
                    if c + 1 < 4 then 
                        c = c + 1
                    else c = 1 end
                    if c == 1 then 
                        vector[j].x = tonumber(num)
                    elseif c == 2 then 
                        vector[j].y = tonumber(num)
                    elseif c == 3 then 
                        vector[j].z = tonumber(num)
                        vector[j].w = 0
                    end  
                            
                end
            end
        end
        if stop == false then 
            j = j+1
        end
    end
    --put together vector into traingles / faces
    local m = {}
    c=1
    for i=#vector+1, #lines do 
        for num in string.gmatch(lines[i],"%S+") do
            if num ~= "f"  then 
                table.insert( m,tonumber( num))
            end
        end
    end
    for i=1, #lines-#vector do 
        triangles[i] = Triangle.new({vector[m[c]], vector[m[c+1]], vector[m[c+2]]})
        c = c +3 
    end
    local result = {}
    for i=1, #triangles do 
        table.insert(result, {triangles[i].vectors[1].x, triangles[i].vectors[1].y, triangles[i].vectors[1].z, 1})
        table.insert(result, {triangles[i].vectors[2].x, triangles[i].vectors[2].y, triangles[i].vectors[2].z, 1})
        table.insert(result, {triangles[i].vectors[3].x, triangles[i].vectors[3].y, triangles[i].vectors[3].z, 1})
    end
    return result
end
