

uniform mat4 ViewMatrix;
uniform mat4 ModelMatrix;
uniform mat4 MATRIXPROJECTION;
//uniform float TIME;


attribute vec4 VertexNormal;
varying vec4 worldPosition;
varying vec4 viewPosition;
varying vec4 screenPosition;
varying vec4 CameraPosition;
varying vec4 v_normal;
varying vec4 vertexPos;


vec4 position(mat4 transformProjection, vec4 vertexPosition) {
    //prepare variables to be passed to fragment shader

    v_normal = normalize(VertexNormal);
    //vertexPos = vertexPosition;

    worldPosition.w = 1;
    worldPosition = vertexPosition * ModelMatrix;
    viewPosition = worldPosition * ViewMatrix;
    vertexPos = worldPosition;
    screenPosition = viewPosition * MATRIXPROJECTION;
    return screenPosition;
}